(defvar bug-repro-mode-syntax-table
  (let ((st (make-syntax-table)))
    (modify-syntax-entry ?$ "$" st)
    (modify-syntax-entry ?% "<" st)
    (modify-syntax-entry ?\n ">" st)
    st))

(defun bug-repro-syntactic-face-function (state)
  (let ((char (nth 3 state)))
    (if char
        font-lock-string-face
      font-lock-comment-face)))

(define-derived-mode bug-repro-mode nil "BugRepro"
  :syntax-table bug-repro-mode-syntax-table
  (add-hook 'pre-command-hook #'syntax-ppss nil t)
  (setq font-lock-multiline t)
  (setq font-lock-defaults
        '(nil nil nil ((?$ . "\""))
              (font-lock-syntactic-face-function
               . bug-repro-syntactic-face-function))))
